/*
  
   This the companion sketch for the B&F Under Glow FX Android app available in the Google Play
  app store: https://play.google.com/store/apps/details?id=com.beardsandfur.underglowfx
  
  This sketch is Based on the Example Skitch WS2812FX Patterns web. with the addition of websocket for sreaming commands.
  also with 4 triggers. Blinkers,Breaks, and 4th optional. and web interfaceto sockets.
  please read docs in library  https://github.com/kitesurfer1404/WS2812FX
  also check out LEDFX as this was the insperation of my app, but modeled for Car Unger Glow Systems. 
  app store: https://play.google.com/store/apps/details?id=com.champlainsystems.ledfx
  

  LICENSE

  The MIT License (MIT)

  Copyright (c) 2018  Shawn Stone

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sub-license, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  CHANGELOG
  2019-03-7 initial version 
 
*/
#include <WS2812FX.h>
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <ArduinoJson.h>
#include <EEPROM.h>
#include <ArduinoOTA.h>
#include <WebSocketsServer.h>
#include <ESP8266mDNS.h>
#define TIMER_MS 3000
#define VERSION "2.1.0"// left in for backwords compat with LEDFX
#include "custom/DualLarson.h"
#include "custom/MultiComet.h"
#include "custom/Oscillate.h"
#include "custom/RainbowLarson.h"
uint8_t  dataPin = D2; // default digital pin used to drive the LED strip
uint16_t numLeds = 298; // default number of LEDs on the strip


#define WIFI_SSID "BeardsAndFur"     // WiFi network
#define WIFI_PASSWORD "elm2346rag3744knot" // WiFi network password
//#define WIFI_SSID "FiOS-0QO4V2"     // WiFi network
#define WEB_SPORT 81
#define HTTP_PORT 80
#define MAX_NUM_PATTERNS 8
//                       duration, brightness, numSegments, [ { first, last, speed, mode, options, colors[] } ]
#define DEFAULT_PATTERN {30, 64, 1, { {0, numLeds-1, numLeds*20, FX_MODE_STATIC, NO_OPTIONS, {RED,  BLACK, BLACK}} }}
typedef struct Pattern { // 208 bytes/pattern
  int duration;
  uint8_t brightness;
  uint8_t numSegments;
  WS2812FX::segment segments[MAX_NUM_SEGMENTS];
} pattern;

// setup a default patterns array
Pattern patterns[MAX_NUM_PATTERNS] = { DEFAULT_PATTERN };
int numPatterns = 1;
int currentPattern = 0;
unsigned long lastTime = 0;
unsigned long last_trigger1 = 0;
unsigned long last_trigger2 = 0;
unsigned long last_trigger3 = 0;
unsigned long last_trigger4 = 0;
const int button1Pin = D5;
const int button2Pin = D6;
const int button3Pin = D7;
const int button4Pin = D8;
bool autoPilet = false;  /// normanly true currently set to false for dev and no floating pins
byte button1State = 0;
byte button1FlagState = 0;
byte button2State = 0;
byte button2FlagState = 0;
byte button3State = 0;
byte button3FlagState = 0;
byte button4State = 0;
byte button4FlagState = 0;
uint32_t rb_colors[3];
uint32_t lb_colors[3];
uint32_t st_colors[3];
uint16_t speeds[3];
uint8_t segoption[3];

uint8_t rb_mode = 25;
uint8_t lb_mode = 25;
uint8_t st_mode = 25;
WS2812FX ws2812fx = WS2812FX(numLeds, dataPin, NEO_GRB + NEO_KHZ800);
ESP8266WebServer server(HTTP_PORT);
WebSocketsServer webSocket = WebSocketsServer(WEB_SPORT);
char webpage[] PROGMEM = R"=====(
<html>
<head>
  <script>
    var Socket;
    function init() {
      Socket = new WebSocket('ws://' + window.location.hostname + ':81/');
      Socket.onmessage = function(event){
        document.getElementById("rxConsole").value += event.data;
      }
    }
    function sendText(){
      Socket.send(document.getElementById("txBar").value);
      document.getElementById("txBar").value = "";
    }
    function sendBrightness(){
      Socket.send("#"+document.getElementById("brightness").value);
    }    
  </script>
</head>
<body onload="javascript:init()">
  <div>
    <textarea id="rxConsole"></textarea>
  </div>
  <hr/>
  <div>
    <input type="text" id="txBar" onkeydown="if(event.keyCode == 13) sendText();" />
  </div>
  <hr/>
  <div>
    <input type="range" min="0" max="255" value="128" id="brightness" oninput="sendBrightness()" />
  </div>
  <div>
      <input type="range" min="0" max="12000" value="1000" id="fxspeed" oninput="sendSpeed()" />
    </div>
</body>
</html>
)=====";
void (*customAuxFunc[])(void) { // define custom auxiliary functions here
  [] {  remoteenable();
    Serial.println("running customAuxFunc[0]"); },
  [] { remotedisble();
    Serial.println("running customAuxFunc[1]"); },
  [] { 
    Serial.println("running customAuxFunc[2]"); }
};

void remoteenable(){
  autoPilet = false;
  
  ws2812fx.setSegment(0,0,59,st_mode,st_colors,speeds[0],segoption[0]);
   ws2812fx.setSegment(1,60,146,rb_mode,rb_colors,speeds[1],segoption[1]);
      ws2812fx.setSegment(3,208,298,lb_mode,lb_colors,speeds[2],segoption[2]);
  //lastTime=0;

  
  }
  void remotedisble(){
  autoPilet = true;
  //lastTime=0;
  ws2812fx.setSegment(0,0,59,st_mode,st_colors,speeds[0],segoption[0]);
   ws2812fx.setSegment(1,60,146,rb_mode,rb_colors,speeds[1],segoption[1]);
      ws2812fx.setSegment(3,208,298,lb_mode,lb_colors,speeds[2],segoption[2]);
         
       
 
  
  }
void setup() {
  Serial.begin(115200);
  delay(500);
  Serial.println("\r\n");

  EEPROM.begin(2048); // for ESP8266 (comment out if using an Arduino)
    WiFi.hostname("BNFUGLOW1");
  // init WiFi
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  WiFi.mode(WIFI_STA);

  Serial.print("Connecting to " WIFI_SSID);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.print("\nServer IP is ");
  Serial.println(WiFi.localIP());
  
  if (!MDNS.begin("BNFUGLOW1")) {
    Serial.println("Error setting up MDNS responder!");
    while (1) {
      delay(1000);
    }
  }
  Serial.println("mDNS responder started");

   MDNS.addService("ws", "tcp", 81); // config and start the web socket mDNS responder
    MDNS.addService("http", "tcp", 80);  // config and start the web server mDNS responder
  // init OTA
  ArduinoOTA.onStart([]() {
    Serial.println("OTA start");
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nOTA end");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
    else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
    else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
    else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
    else if (error == OTA_END_ERROR) Serial.println("End Failed");
  });
  ArduinoOTA.begin();

 
  // init LED strip with a default segment
   uint32_t colors[] = {RED, BLUE, GREEN};
  uint8_t multiCometMode  = ws2812fx.setCustomMode(F("MultiComet"), multiComet);
  uint8_t oscillateMode  = ws2812fx.setCustomMode(F("Oscillate"), oscillate);
  uint8_t rainbowLarsonMode  = ws2812fx.setCustomMode(F("Rainbow Larson"), rainbowLarson);
  uint8_t dualLarsonMode  = ws2812fx.setCustomMode(F("Dual Larson"), dualLarson); 
  ws2812fx.init();
  ws2812fx.setBrightness(128);
  ws2812fx.setSegment(0, 0, numLeds - 1, FX_MODE_STATIC, RED, 3000, false);

  // if not rebooting due to catastrophic error, restore pattern data from eeprom
  struct  rst_info  *rstInfo = system_get_rst_info();
  //Serial.print("rstInfo->reason:"); Serial.println(rstInfo->reason);
  if (rstInfo->reason !=  REASON_EXCEPTION_RST) { // not reason 2
    restoreFromEEPROM();
  }

  ws2812fx.start();
   
  configServer();// config and start the web server
    server.begin();
  webSocket.begin();//  start the web socket server 
  webSocket.onEvent(webSocketEvent);
  
}

void leftTurn(){
  if(autoPilet){
      ws2812fx.setSegment(3, 208, 298, FX_MODE_BLINK, YELLOW, 800, false);// my setup. in learning to solder i killed a couple pixels
      //ws2812fx.setSegment(3, 210, 299, FX_MODE_BLINK, YELLOW, 800, false); //standerd setup
  ws2812fx.start();
    button1FlagState = 1;
  }else{
    }
  }

void rightTurn(){
   if(autoPilet){
    ws2812fx.setSegment(1, 60, 146, FX_MODE_BLINK, YELLOW, 800, false);  // my setup. in learning to solder i killed a couple pixels
   // ws2812fx.setSegment(1, 60, 149, FX_MODE_BLINK, YELLOW, 800, false); //standerd setup
  ws2812fx.start();
  button2FlagState = 1;
   }
  
  }
  

void breakLight(){
   if(autoPilet){
  ws2812fx.setSegment(0, 0, 59, FX_MODE_BLINK, RED, 800, false);
  button3FlagState = 1;
   }
  }

void customTrigger(){
  
  button4FlagState = 1;
  }


void loop() {
   ArduinoOTA.handle();
  ws2812fx.service();
  server.handleClient();
  webSocket.loop();
 //  MDNS.update();
  if(Serial.available() > 0){
    char c[] = {(char)Serial.read()};
    webSocket.broadcastTXT(c, sizeof(c));
  }

  // if it's time to change pattern, do it now
  unsigned long now = millis();
  if (lastTime == 0 || (now - lastTime > patterns[currentPattern].duration * 1000)) {
    ws2812fx.clear();
    ws2812fx.resetSegments();

    currentPattern = (currentPattern + 1) % numPatterns;
    ws2812fx.setBrightness(patterns[currentPattern].brightness);
    for (int i = 0; i < patterns[currentPattern].numSegments; i++) {
      WS2812FX::segment seg = patterns[currentPattern].segments[i];
      ws2812fx.setSegment(i, seg.start, seg.stop, seg.mode, seg.colors, seg.speed, seg.options);
                  
           
    }
          segoption[0] = patterns[currentPattern].segments[0].options;
          segoption[1] = patterns[currentPattern].segments[1].options;
          segoption[2] = patterns[currentPattern].segments[3].options;
          speeds[0]= patterns[currentPattern].segments[0].speed;
          speeds[1]= patterns[currentPattern].segments[1].speed;
          speeds[2]= patterns[currentPattern].segments[3].speed;
           rb_colors[0] = patterns[currentPattern].segments[1].colors[0];
           rb_colors[1] = patterns[currentPattern].segments[1].colors[1];
           rb_colors[2] = patterns[currentPattern].segments[1].colors[2];
           lb_colors[0] = patterns[currentPattern].segments[3].colors[0];
           lb_colors[1] = patterns[currentPattern].segments[3].colors[1];
           lb_colors[2] = patterns[currentPattern].segments[3].colors[2];
           st_colors[0] = patterns[currentPattern].segments[0].colors[0];
           st_colors[1] = patterns[currentPattern].segments[0].colors[1];
           st_colors[2] = patterns[currentPattern].segments[0].colors[2];
       
          
           st_mode = patterns[currentPattern].segments[0].mode;
           rb_mode = patterns[currentPattern].segments[1].mode;
           lb_mode =  patterns[currentPattern].segments[3].mode;
           lastTime = now;
  }

    
   //furball :read veh lights {leftturn,rightturn,break,reverse)if high = lights active
    //using voltage spliter to reduse 12v to under 3v. fun part you do the math or google it
  
      button1State = digitalRead(button1Pin);
      button2State = digitalRead(button2Pin);
      button3State = digitalRead(button3Pin);
      button4State = digitalRead(button4Pin);

     if(button1State == HIGH ){
     // stops repeted strip set to allow cycle the patern
    if(now - last_trigger1 > TIMER_MS) {
      leftTurn();
     last_trigger1 = now;     
          }
        }
      if(button2State == HIGH ){       
    // stops repeted strip set to allow cycle thre patern
    if(now - last_trigger2 > TIMER_MS) {
      rightTurn();
     last_trigger2 = now;    
           }
        }
   if(button3State == HIGH ){      
    // stops repeted strip set to allow cycle thre patern
    if(now - last_trigger3 > TIMER_MS) {
     breakLight();
     last_trigger3 = now;         
           }
        }
 if(button4State == HIGH ){
  // stops repeted strip set to allow cycle thre patern
     if(now - last_trigger4 > TIMER_MS) {
          customTrigger();
        last_trigger4 = now;        
                }
         }

       // clear pattern and return to base pattern
        
         if(now - last_trigger1 > 5000 && button1FlagState == 1) {
          // lastTime=0;
            ws2812fx.setSegment(1,60,146,rb_mode,rb_colors,speeds[1],segoption[1]);
        //  ws2812fx.setSpeed(speeds[1]);
        //  ws2812fx.setColors(1,rb_colors);
        // ws2812fx.setMode(1,rb_mode);
     last_trigger1 = now;
     button1FlagState = 0;
     
         }
         if(now - last_trigger2 > 5000 && button2FlagState == 1){
             //lastTime=0;
             ws2812fx.setSegment(3,208,298,lb_mode,lb_colors,speeds[2],segoption[2]);
            // ws2812fx.setSpeed(speeds[2]);
            // ws2812fx.setColors(3,lb_colors);
             // ws2812fx.setMode(3,lb_mode);
         last_trigger2 = now;
         button2FlagState = 0;

         }
         if(now - last_trigger3 > 5000 && button3FlagState == 1){
             //lastTime=0;
                     ws2812fx.setSegment(0,0,59,st_mode,st_colors,speeds[0],segoption[0]);
            //  ws2812fx.setSpeed(speeds[0]);
         // ws2812fx.setColors(0,st_colors);
         // ws2812fx.setMode(0,st_mode);
          
             
         last_trigger3 = now;
         button3FlagState = 0;

         }
         if(now - last_trigger4 > 5000 && button4FlagState == 1){
             lastTime=0;
         last_trigger4 = now;
         button4FlagState = 0;

         }
  
}

void configServer() {
  server.onNotFound([]() {
    server.sendHeader("Access-Control-Allow-Origin", "*");
    server.send(404, "text/plain", "Page not found");
  });

  server.on("/",[](){
    server.send_P(200, "text/html", webpage);  
  });
  // return the WS2812FX status
  // optionally set the running state or run custom auxiliary functions
  server.on("/status", []() {
    server.sendHeader("Access-Control-Allow-Origin", "*");
    String running = server.arg("running");
    if (running.length() > 0) {
      if (running == "true") ws2812fx.start();
      else ws2812fx.stop();
    }

    String auxFunc = server.arg("auxFunc");
    if (auxFunc.length() > 0) {
      int auxFuncIndex = auxFunc.toInt();
      if (auxFuncIndex >= 0 && auxFuncIndex < sizeof(customAuxFunc) / sizeof(customAuxFunc[0])) {
        customAuxFunc[auxFuncIndex]();
      }
    }

    char status[50] = "{\"version\":\"";
    strcat(status, VERSION);
    strcat(status, "\",\"isRunning\":");
    strcat(status, ws2812fx.isRunning() ? "true" : "false");
    strcat(status, "}");
    server.send(200, "application/json", status);
  });

  // send the WS2812FX mode info in JSON format
  server.on("/getModes", []() {
    char modes[1000] = "[";
    for (uint8_t i = 0; i < ws2812fx.getModeCount(); i++) {
      strcat(modes, "\"");
      strcat_P(modes, (PGM_P)ws2812fx.getModeName(i));
      strcat(modes, "\",");
    }
    modes[strlen(modes) - 1] = ']';

    server.sendHeader("Access-Control-Allow-Origin", "*");
    server.send(200, "application/json", modes);
  });

  server.on("/upload", HTTP_OPTIONS, []() { // CORS preflight request
    server.sendHeader("Access-Control-Allow-Origin", "*");
    server.sendHeader("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
    server.sendHeader("Access-Control-Allow-Methods", "POST, GET, OPTIONS");
    server.send(200, "text/plain", "OK");
  });

  // receive the device info in JSON format and update the pattern data
  server.on("/upload", HTTP_POST, []() {
    String data = server.arg("plain");
    Serial.println(data);

    bool isParseOk = json2patterns(data);

    if (isParseOk && numPatterns > 0) {
      ws2812fx.stop();
      ws2812fx.clear();
      ws2812fx.resetSegments();

      saveToEEPROM();

      currentPattern = 0;
      lastTime = 0;
      ws2812fx.start();
      
    }

    server.sendHeader("Access-Control-Allow-Origin", "*");
    server.send(200, "application/json", "{\"status\":200, \"message\":\"OK\"}");
  });
}

#define EEPROM_MAGIC_NUMBER 0x010e0d05
void saveToEEPROM() {
  Serial.println("saving to EEPROM");
  EEPROM.put(sizeof(int) * 0, (int)EEPROM_MAGIC_NUMBER);
  EEPROM.put(sizeof(int) * 1, (int)ws2812fx.getPin());
  EEPROM.put(sizeof(int) * 2, (int)ws2812fx.getLength());
  EEPROM.put(sizeof(int) * 3, (int)numPatterns);
  EEPROM.put(sizeof(int) * 4, patterns);
  EEPROM.commit(); // for ESP8266 (comment out if using an Arduino)
   
}

void restoreFromEEPROM() {
  int magicNumber = 0;
  int pin;
  int length;
  EEPROM.get(sizeof(int) * 0, magicNumber);
  if (magicNumber == EEPROM_MAGIC_NUMBER) {
    Serial.println("restoring from EEPROM");
    EEPROM.get(sizeof(int) * 1, pin);
    if (ws2812fx.getPin() != pin) {
      ws2812fx.setPin(pin);
    }
    EEPROM.get(sizeof(int) * 2, length);
    if (ws2812fx.getLength() != length) {
      ws2812fx.setLength(length);
    }
    EEPROM.get(sizeof(int) * 3, numPatterns);
    EEPROM.get(sizeof(int) * 4, patterns);
  }
}

int modeName2Index(const char* name) {
  for (int i = 0; i < ws2812fx.getModeCount(); i++) {
    if (strcmp_P(name, (PGM_P)ws2812fx.getModeName(i)) == 0) {
      return i;
    }
  }
  return 0;
}

#if ARDUINOJSON_VERSION_MAJOR == 5
//#pragma message("Compiling for ArduinoJson v5")
bool json2patterns(String &json) {
  DynamicJsonBuffer jsonBuffer(2000);
  JsonObject& deviceJson = jsonBuffer.parseObject(json);
  if (deviceJson.success()) {
    ws2812fx.setPin(deviceJson["dataPin"]);
    ws2812fx.setLength(deviceJson["numLeds"]);

    JsonArray& patternsJson = deviceJson["patterns"];
    if (patternsJson.size() > 0 ) {
      numPatterns = 0;
      for (int i = 0; i < patternsJson.size(); i++) {
        JsonObject& patt = patternsJson[i];
      bool isEnabled = patt["isEnabled"];
      if (! isEnabled) continue; // disabled patterns are not stored

        JsonArray& segmentsJson = patt["segments"];
        if (segmentsJson.size() == 0 ) continue;

        patterns[numPatterns].brightness = patt["brightness"];
        patterns[numPatterns].duration = patt["duration"];

        patterns[numPatterns].numSegments = segmentsJson.size();
        for (int j = 0; j < segmentsJson.size(); j++) {
          JsonObject& seg = segmentsJson[j];
          //seg.printTo(Serial);Serial.println();
          int start = seg["start"];
          if (start < 0 || start >= ws2812fx.getLength()) start = 0;
          patterns[numPatterns].segments[j].start = start;

          int stop = seg["stop"];
          if (stop < 0 || stop >= ws2812fx.getLength()) stop = ws2812fx.getLength() - 1;
          patterns[numPatterns].segments[j].stop = stop;

          if (seg["mode"].is<unsigned int>()) { // seg["mode"] can be a mode number or a mode name
            patterns[numPatterns].segments[j].mode = seg["mode"];
          } else {
            patterns[numPatterns].segments[j].mode = modeName2Index(seg["mode"]);
          }

          int speed = seg["speed"];
          if (speed < SPEED_MIN || speed >= SPEED_MAX) speed = 1000;
          patterns[numPatterns].segments[j].speed = speed;

          patterns[numPatterns].segments[j].options = 0;
          bool reverse = seg["reverse"];
          if (reverse) patterns[numPatterns].segments[j].options |= REVERSE;

          bool gamma = seg["gamma"];
          if (gamma) patterns[numPatterns].segments[j].options |= GAMMA;

          int fadeRate = seg["fadeRate"];
          if (fadeRate > 0) patterns[numPatterns].segments[j].options |= (fadeRate & 0x7) << 4;

          int size = seg["size"];
          if (size > 0) patterns[numPatterns].segments[j].options |= (size & 0x3) << 1;

          JsonArray& colors = seg["colors"]; // the web interface sends three color values
          // convert colors from strings ('#ffffff') to uint32_t
          patterns[numPatterns].segments[j].colors[0] = strtoul(colors[0].as<char*>() + 1, 0, 16);
          patterns[numPatterns].segments[j].colors[1] = strtoul(colors[1].as<char*>() + 1, 0, 16);
          patterns[numPatterns].segments[j].colors[2] = strtoul(colors[2].as<char*>() + 1, 0, 16);
        }
        numPatterns++;
        if (numPatterns >= MAX_NUM_PATTERNS) break;
      }
    } else {
      Serial.println(F("JSON contains no pattern data"));
      return false;
    }
  } else {
    Serial.println(F("Could not parse JSON payload"));
    return false;
  }
  return true;
}
#endif



void webSocketEvent(uint8_t num, WStype_t type, uint8_t * payload, size_t length){
  if(type == WStype_TEXT){
    if(payload[0] == '#'){
      uint8_t brightness = (uint8_t) strtol((const char *) &payload[1], NULL, 10);
       
      ws2812fx.setBrightness(brightness);
       webSocket.sendTXT(num,"brightness set");
     
    }else if(payload[0] == 'M'){
      uint8_t fxmode = (uint8_t) strtol((const char *) &payload[1], NULL, 10);

       ws2812fx.setMode(0, fxmode);
       ws2812fx.setMode(1, fxmode);
       ws2812fx.setMode(2, fxmode);
       ws2812fx.setMode(3, fxmode);
    
      webSocket.sendTXT(num, "Mode set");

    }else if(payload[0] == 'N'){
        currentPattern = 0;
         lastTime = 0;
           ws2812fx.start();
           webSocket.sendTXT(num, "Rest Good");
         

          }else if(payload[0] == 'O'){
          ws2812fx.start();
          // Serial.println("start");
         webSocket.sendTXT(num, "Start ok");
           }else if(payload[0] == 'o'){
                    ws2812fx.stop();
                     //Serial.println("stop");
                 webSocket.sendTXT(num, "Stop ok");
          }else if(payload[0] == 'E'){
           uint16_t fxspeed = (uint16_t) strtol((const char *) &payload[1], NULL, 10);
      
         ws2812fx.setSpeed(0,fxspeed);
         ws2812fx.setSpeed(1,fxspeed);
         ws2812fx.setSpeed(2,fxspeed);
         ws2812fx.setSpeed(3,fxspeed);
        webSocket.sendTXT(num, "Speed set");
    

             }else if(payload[0] == 'S'){
               ws2812fx.increaseSpeed(1000);
           

              }else if(payload[0] == 's'){
                 ws2812fx.decreaseSpeed(1000);
           

              }else if(payload[0] == 'b'){
     
                  ws2812fx.decreaseBrightness(25);

              }else if(payload[0] == 'B'){
                ws2812fx.increaseBrightness(25);
           

              }else if(payload[0] == 'R'){
                  ws2812fx.resume();
           

              }else if(payload[0] == 'r'){
                  ws2812fx.pause();
           

              
         }else if(payload[0] == 'C'){
           uint8_t col = (uint8_t) strtol((const char *) &payload[1], NULL, 10);
                long fbc[12] = { RED,GREEN,BLUE,WHITE,BLACK,YELLOW,CYAN,MAGENTA,PURPLE,ORANGE,PINK,ULTRAWHITE};
             ws2812fx.setColor(0,fbc[col]);ws2812fx.setColor(1,fbc[col]);ws2812fx.setColor(2,fbc[col]);ws2812fx.setColor(3,fbc[col]);
        
    }else{
      for(int i = 0; i < length; i++)
        Serial.print((char) payload[i]);
      Serial.println();
    }

    

    
  }
  
}
